print("###### list slicing ###### ")

L = [0,10,20,30,40,50]
print(L[1:4])     # [10,20,30] (40은 포함되지 않음)
print(L[0:3])     # [0,10,20] (30은 포함되지 않음)
print(L[:3])      # [0,10,20] (L[0:3]과 같음) 
print(L[2:6])     # [20,30,40,50] 
print(L[2:])      # [20,30,40,50]  (L[2:6]과 같음)
print(L[:])       # [0,10,20,30,40,50]


print("###### list slicing ###### ")

L = [0,10,20,30,40,50,60,70,80,90]
print(L[1:9:2])     # [10,30,50,70] (2씩 건너뜀)
print(L[:9:2])      # [0,20,40,60,80]
print(L[1::2])      # [10,30,50,70,90]
print(L[1:-1:2])    # [10,30,50,70]  (리스트 인덱스에서 -1은 맨 마지막 원소를 의미) 



print("###### list operation ###### ")
L = [1,2,3] 
M = [1,2,3] 
N = [1,3,2]
print(L == M)   # True
print(L == N)   # False



L = [0,1,2,3,4,5] 
print(3 in L)        # True 
print(8 in L)        # False 
print(8 not in L)    # True 
print([1,2] in L)     # False  
print([1,2] in [0, [1,2 ],3])   # True

L = [0,1] + [2,3,4,5]         # [0,1,2,3,4,5] 연결
M = [0,1] * 3              # [0,1,0,1,0,1] 반복 
print(L,M)

L = [1,2,3,4,5] 
print (sum(L))  # 15 
print (max(L))  # 5 
print (min(L))   # 1

help(list)

print("###### list append ###### ")

number = [ 2, 5, 8, 11, 14 ] 

number = [ None ] * 5   # [ None, None, None, None, None ] 이 생성됨 
number[0] = 2  
number[1] = 5  
number[2] = 8  
number[3] = 11  
number[4] = 14

print (number)
 
print("###### list index ###### ") 
for i in range(len(number)):       
   print(number[i])  


print("###### append / extend / + ###### ") 



L = [1,2,3]
print (L.append(4), L)     # None [1, 2, 3, 4] 즉 append의 인자는 하나의 객체

L = [1,2,3]
print(L.append([4,5,6]), L) #None [1, 2, 3, [4, 5, 6]]  리스트 역시 하나의 객체로 통째로 추가

L = [1,2,3]             
#print(L.extend(4), L)   #builtins.TypeError: 'int' object is not iterable  
                      # 즉 extend의 인자로 iterable한 객체가 아닌 정수는 오류를 발생함 

L = [1,2,3]
print(L.extend([4,5,6]), L)  #None [1, 2, 3, 4, 5, 6]  리스트의 모든 원소가 하나씩 원소로 추가

L = [1,2,3]
print(L.extend("python"), L)  #None [1, 2, 3, 'p', 'y', 't', 'h', 'o', 'n']  문자열은 iterable 객체 

 
L = [1,2,3]
M = [4,5,6]
print(L + M, L , M)   #[1, 2, 3, 4, 5, 6] [1, 2, 3] [4, 5, 6]

print("###### list comprehension ###### ") 
a = [ ]
for x in range(10) :
   if  x %2 == 1 :
      a.append(x**2)

print("###### random ###### ") 
import random

a = [ ]                         # 맨 처음 빈 리스트를 생성한후  
for i in range(10):
   x = random.randint(1,10)   # 1부터 10사이의 정수 생성하여 
   a.append(x)               # 리스트에 추가하기 
print (a)  # [5, 10, 6, 8, 3, 9, 5, 7, 8, 7]  -> 수행 할때마다 다른 결과가 나옴

b = [ ]
for i in range(5):
   x = random.random()   # 0부터 1보다 작은 실수 생성
   b.append(x)
print (b)     

c = [1,2,3,4,5,6,7,8,9,10]
random.shuffle(c)           # 리스트 c를 임의로 섞어주는 효과
print (c)


a = [ ]
for i in range(7):
   x = random.randint(1,45)
   a.append(x)
print (a)  # [19, 8, 31, 31, 16, 41, 30]

a = [ ]
while len(a) < 7 :
   x = random.randint(1,45)
   if x not in a :     # not in 연산자를 이용하여 리스트 a에 없는 경우에만 추가하기
      a.append(x)
print (a)  # [36, 39, 31, 19, 21, 8, 10]

a = [None] * 45   # 크기가45인 리스트를 None으로 초기화
for i in range (45):
   a[i] = i + 1    # 1부터 45까지 숫자로 이루어진 리스트 a를 생성하기
random.shuffle(a)  # 리스트 a의 항목을 섞음
b = a[0:7]         # 리스트 a의 처음 7개로 이루어진 새로운 리스트 b 생성
print (b)
