class Point:                        # Point class 정의
    def __init__(self, px, py):     # Point클래스의 생성자로 modifier
        self.x = px                 # Point 클래스에는 x와 y라는 두개의 속성이 정의됨
        self.y = py
        
    def __str__ (self):         # Point 객체를 print 함수로 출력할 때 호출되는 메소드
        return "(" + str(self.x) + "," + str(self.y) + ")"  # 문자열형태를 리턴함
    

    def getX(self):     # getter method는 속성값을 리턴
        return self.x
    
    def getY(self): 
        return self.y
    
    def setX(self, v):   # setter method는 인자로 받은 값으로 속성값을 변경함
        self.x = v       # return 값이 없으므로 None 이 return   
    
    def setY(self, v): 
        self.y = v

    def distance(self, p): # Point 객체 p를 매개변수로 입력받아 두점간의 거리를 계산
        dx = self.x - p.x 
        dy = self.y - p.y 
        return (dx**2+dy**2)**0.5

    def add(self, p):           # 두 점의 벡터 합으로 새로운 Point 객체를 생성하여 리턴
        x = self.x + p.x        # x와 y는 임시 변수
        y = self.y + p.y 
        return Point(x,y)     # Point()를 이용하여 새로운  Point 객체를 생성하여 리턴

    def add_as_modifier(self, p): # 파라메터만큼의 벡터값을 Point 객체에 더하는 modifier
        self.x = self.x + p.x         
        self.y = self.y + p.y 

def point_main() :      #테스트를 위한 함수임
    p1 = Point(1,2)    # Point 객체를 생성하기  __init__() 가 자동 호출됨
    p2 = Point(4,6) 
    print(p1, p2)      # p1.__str__()과 p2.__str__() 가 호출됨

    print(p1.distance(p2))   
    print(p2.distance(p1))   

    p3 = p1.add(p2)
    print(p3)   
    print(p1)   

    p4 = p1.add_as_modifier(p2)
    print(p4)   
    print(p1)   
    
    p1.setX(7)
    print(p1)            
    print(p1.getX())    # 게터 메소드로 p1객체의 x값이 리턴되어 출력됨
    print(p1.setX(9))   #세터 메소드로 p1의 x 값이 변경되지만 리턴값은 없으므로 None출력

if __name__ == '__main__': 
    point_main()   # import 된것이 아닌 main으로 수행 될때만 실행하기
        
 