def concordance(fileName):
    words = dict()                               # 빈 딕셔너리 words를 생성
    file = open(fileName, "r")                     # 문자열 파일을 읽기 모드로 열기
    lineNo = 0
    for line in file:                               # 파일의 한줄씩 line으로 읽기
        lineNo += 1                              
        for w in line.split():                       # 한 줄을 단어별로 분할   
            word = w.lower()       # 모두 소문자로 변환 즉 Imagine와 imagine를 같이 취급 
            if word not in words:              # 해당하는 단어가 딕셔너리에 없는 경우에는
                words[word] = [lineNo]       # 단어를 key로 하여 새로운 리스트를 추가
            else:                            # 이미 해당 단어가 딕셔너리에 포함된 경우
                if words[word][-1] != lineNo:  # 현재줄 번호가 리스트의 마지막과 다를 때만  
                    words[word].append(lineNo)  # 현재 줄번호를 추가하기
                    # (즉 동일 라인에 2번 이상 같은 단어가 나올 때는 한번만 표기하게 함
    return words

def printConcordance(d):
    keys = list(d.keys())                  # key 값인 단어를 기준으로 리스트 생성 후 정렬
    keys.sort()
    
    for key in keys:
        print("%20s: " % key, end=" ")     # key 출력 후 줄 바꿈 없이 옆으로 계속 출력 
        for lineNo in d[key]:           # 리스트로 표현된 라인 번호들을 for 이용 반복 출력
            print("%d," % lineNo, end=" ")
        print()                       # 하나의 key가 끝나면 줄 바꿈 수행 
        
d = concordance("imagine.txt")
print (d)                                         
printConcordance(d)
