#-------------------------------------- 
#  핑퐁 게임 만들기
#-------------------------------------- 
from turtle import *
#--------------------------------------
#   게임요소 만들기
#--------------------------------------
#### screen  만들기 ####
scr = Screen()
scr.setup(500, 700)
scr.bgcolor ("lightyellow")
scr.title("핑퐁게임")
 
#### ball 만들기 ####
ball = Turtle ("circle") 
ball.color("red")
ball.hideturtle()     # 거북이 모양을 안보이게 한후 
ball.up()             # 궤적이 남지 않도록 펜을 올리고
ball.goto (0,270)     # (0,270) 위치로 옮기기
ball.showturtle()     # 공 모양을 다시 보이도록 함
 
#### bar 만들기  ####
bar = Turtle ()
bar.shape ("square")
bar.color("blue")
bar.shapesize (0.5,5)   # 단위1이 한 20 픽셀 그러므로 10*100 짜리 막대가 생김 
bar.up()
bar.goto (0,-270)
 
#### 게임 메시지 만들기 ####
message= Turtle()
message.color("blue")
message.penup()          # 궤적이 남지 않도록 펜을 올리고 
message.hideturtle()     # 거북이 모양을 안보이게 하기 
message.goto(0, 300)
message.write("남아 있는 ball 수 : 3 " , align="center",  font=("Arial", 16, "bold"))

#--------------------------------------
#   함수 만들기
#--------------------------------------
#right()  화살표 키로 bar 오른쪽 움직이기
def right():
    if bar.xcor() < 200 :
        bar.forward(20) 
     
#left() 화살표 키로 bar 왼쪽 움직이기
def left():
    if -200 < bar.xcor() :
        bar.backward(20) 
 
# ball 이 bar와 만나는지 체크 
def hit_bar() :
    if (-264 < ball.ycor() < -251) and  ( bar.xcor() - 60 < ball.xcor() < bar.xcor() + 60) : 
        return True  
    return False
    
#### bar를 움직이는 키보드 입력 셋팅   ####
scr.listen()
scr.onkeypress(right, "Right")
scr.onkeypress(left, "Left")

#--------------------------------------
# 게임의 main loop
#--------------------------------------
game_on = True
x_move = 5
y_move = -5
game_count = 3

while game_on :   # while True 형식임
    if  ball.xcor() <= -235 or   ball.xcor() >= 235 : # 양쪽 옆 벽에 닿는 경우 방향 전환
        x_move *= -1 
      
    if  ball.ycor() >= 345    :   # 윗 벽에 닿는 경우 방향 전환
        y_move *= -1       
      
    if hit_bar() :        # bar에서 맞춰서 뱡향 전환
        y_move *= -1
      
    new_x = ball.xcor() + x_move
    new_y = ball.ycor() + y_move
    ball.goto(new_x, new_y)
      
    if ball.ycor() <= -355 :   # 아래방향으로 볼이 빠진 경우 
        if game_count > 1 :     # 아직 남아있는 게임이 있으면 다시 시작하기
            game_count -= 1
            message.clear()
            message.write("남아 있는 ball 수 :   " + str(game_count) , \
                align="center",  font=("Arial", 16, "bold"))
            ball.hideturtle() 
            ball.goto (0,270) 
            ball.showturtle()
        else:
            message.clear()
            message.write("게임이 끝났습니다." , align="center",  font=("Arial", 16, "bold"))
            game_on = False
