from Point import Point
 
class Rectangle:
    def __init__(self, p1,p2):
        self.p1 = p1
        self.p2 = p2
        
    def __str__(self):
        return "[" + self.p1.__str__() + "," + self.p2.__str__() + "]"
    
    def get_min_x(self):
        return min(self.p1.getX(), self.p2.getX())
        
    def get_min_y(self):
        return min(self.p1.getY(), self.p2.getY())
        
    def get_max_x(self):
        return max(self.p1.getX(), self.p2.getX())
    
    def get_max_y(self):
        return max(self.p1.getY(), self.p2.getY())
        
    def contains(self, p3):   
        return self.get_min_x() <= p3.getX() <= self.get_max_x() and \
               self.get_min_y() <= p3.getY() <= self.get_max_y()
        
    def area(self):
        width = self.get_max_x() - self.get_min_x()
        height = self.get_max_y() - self.get_min_y()
        return width * height
        
    def isEqual(self, other):
        return self.get_min_x() == other.get_min_x() and \
               self.get_max_x() == other.get_max_x() and \
               self.get_min_y() == other.get_min_y() and \
               self.get_max_y() == other.get_max_y()
        
####################################################        
def test():
    p1, p2, p3, p4 = Point(1,1), Point(4,5), Point(5,0), Point(2,3)
    p5, p6, p7, p8 = Point(4,3), Point(0,0), Point(2,0), Point(5,3)    
    r1, r2, r3 = Rectangle(p1,p2), Rectangle(p3,p4), Rectangle(p7,p8) 

    print(r1, r2, r3)   
    print(r1.area())    
    print(r2.area())    
    print(r3.area())    
    print(r1.contains(p4))    
    print(r1.contains(p5))   
    print(r2.contains(p6))   
    print(r1.isEqual(r3))    
    print(r2.isEqual(r3))    
    print(r1.isEqual(r1))    

test()
