class Point:
    # modifier
    def __init__(self, px, py):
        self.x = px
        self.y = py

    # pure function
    def __str__(self):
        return "(" + str(self.x) + ',' + str(self.y) + ")"
        
    # pure function
    def getX(self):
        return self.x
    
    # pure function
    def getY(self) :
        return self.y
    
    # modifier
    def setX(self, v):
        self.x = v
        
    # modifier
    def setY(self, v):
        self.y = v
        
    # pure function
    def distance(self, p):
        dx = self.x - p.x
        dy = self.y - p.y
        return (dx*dx + dy*dy)**0.5
    
    # pure function
    def add(self, p):
        x = self.x + p.x
        y = self.y + p.y
        return Point(x,y)

    # modifier version of the add function
    def add_as_modifier(self, p):
        self.x += p.x
        self.y += p.y
        
        
def point_main() :
    p1 = Point(1,2)  
    p2 = Point(4,6) 
    print(p1, p2)   # (1,2) (4,6)

    print(p1.distance(p2))  # 5.0
    print(p2.distance(p1))  # 5.0

    p3 = p1.add(p2)
    print(p3)  # (5,8)
    print(p1)  # (1,2)

    p4 = p1.add_as_modifier(p2)
    print(p4)  # None
    print(p1)  # (5,8)
    
    p1.setX(7)
    print(p1)          # (7,8)
    print(p1.getX())   # 7
    print(p1.setX(9))  # None

if __name__ == '__main__': point_main()

 
